d("changePasswordView",['ccrz', 'util'], function(CCRZ, UTIL) {
    return {
        extendChangePasswordView: function() {
            if(CCRZ.changePasswordView){
                CCRZ.changePasswordView.viewName = 'changePasswordView';
                document.title = 'Change Password';
                CCRZ.pubSub.once("view:changePasswordView:refresh", function(cpView) {
                    $('.changePasswordContainer .cc_change_password').prepend('<div class="messagingSection-CP-Error my-3" style="display: none"><div class="alert alert-danger"></div></div>');
                    $('.changePasswordContainer').addClass('container customContainer myAccountContainer');
                    $('.changePasswordContainer .cc_btn_submit').addClass('btn-primary roundedCorners');
                    $('.changePasswordContainer .cc_heading').addClass('px-0 mx-4');
                    $('.changePasswordContainer .cc_title').removeClass('panel-title');
                    $('.changePasswordContainer .cc_btn_submit').removeClass('btn-default');
                    $('.changePasswordContainer .cc_title').css('font-size', '1.5rem');
                    $('.changePasswordContainer .cc_btn_submit').prop('disabled', true);
                    $('.cc_password_requirements').html(CCRZ.processPageLabelMap('KFB2B_all_passwordRequirements').toString());
                    cpView.events['blur #NewPassword'] = 'handleNewPassword';
                    cpView.events['blur #ConfirmPassword'] = 'handleConfirmPassword';
                    cpView.events['input #NewPassword'] = 'handleInputPassword';
                    cpView.events['input #ConfirmPassword'] = 'handleInputPassword';
                    cpView.events['click #submit'] = 'resetPasswordCustom';
                    // Init Values
                    cpView.model.set('isNewPassword', false);
                    cpView.model.set('isConfirmPassword', false);
                    cpView.model.set('isMatch', false);
                    // Override the resetPassword
                    cpView.resetPasswordCustom = function(event){
                        let form = this.$el.find("#resetForm").serializeObject(), view = this;
                        this.invoke(
                            "resetPassword",
                            {storefront:CCRZ.pagevars.storefrontName,portalUserId:CCRZ.pagevars.portalUserId},
                            form.NewPassword,
                            form.ConfirmPassword,
                            function(response){
                                if(response.success){
                                    window.location.href = window.location.origin +  CCRZ.pageUrls.homePage + '?cartID=' + getCSRQueryString();
                                }else{
                                    $.each(response.messages,function(){
                                        let message = this.message;
                                        if(this.labelId){
                                            message = CCRZ.pagevars.pageLabels[this.labelId];
                                        }
                                        view.updateError(true, message);
                                    });
                                }
                            }
                        );
                    }
                    // New Password Validation
                    cpView.handleNewPassword = function(){
                        let value = event.target.value, isValid = false, _this = this;
                        if(value == ''){
                            _this.updateError(true, CCRZ.processPageLabelMap('KFB2B_all_newPasswordError').toString());
                        } else {
                            if (UTIL.validate(event.target) == false) {
                                _this.updateError(true, CCRZ.processPageLabelMap('KFB2B_all_passwordCriteriaError').toString());
                            } else {
                                isValid = true;
                            }
                        }
                        _this.model.set('isNewPassword', isValid);
                        if(isValid && !_this.checkPasswordEqual()){
                            _this.updateError(true, CCRZ.processPageLabelMap('KFB2B_all_passwordMatchError').toString());
                        } else {
                            _this.updateError(false, '');
                            _this.validateBtn();
                        }
                    };
                    // Confirm Password Validation
                    cpView.handleConfirmPassword = function(){
                        let value = event.target.value, isValid = false, _this = this;
                        if(value == ''){
                            _this.updateError(true, CCRZ.processPageLabelMap('KFB2B_all_confirmPasswordRequired').toString());
                        } else {
                            if (UTIL.validate(event.target) == false) {
                                _this.updateError(true, CCRZ.processPageLabelMap('KFB2B_all_passwordCriteriaError').toString());
                            } else {
                                isValid = true;
                            }
                        }
                        _this.model.set('isConfirmPassword', isValid);
                        if(isValid && !_this.checkPasswordEqual()){
                            _this.updateError(true, CCRZ.processPageLabelMap('KFB2B_all_passwordMatchError').toString());
                        } else {
                            _this.updateError(false, '');
                            _this.validateBtn();
                        }
                    };
                    cpView.checkPasswordEqual = function(){
                        return $('#NewPassword').val() === $('#ConfirmPassword').val();
                    };
                    cpView.validateFields = function(){
                        let _this = this;
                        return _this.model.get('isNewPassword') && _this.model.get('isConfirmPassword') && _this.model.get('isMatch');
                    };
                    cpView.handleInputPassword = function(){
                        let _this = this;
                        _this.model.set('isMatch', _this.checkPasswordEqual());
                        _this.validateBtn();
                    }
                    cpView.updateError = function(isShow, message){
                        if(isShow){
                            $('.messagingSection-CP-Error .alert').html(message);
                            $('.messagingSection-CP-Error').css('display', 'block');
                        } else {
                            $('.messagingSection-CP-Error').css('display', 'none');
                        }
                    }
                    cpView.validateBtn = function(){
                        if(this.validateFields()){
                            $('.changePasswordContainer .cc_btn_submit').prop('disabled', false);
                            $('.messagingSection-CP-Error').css('display', 'none');
                        } else {
                            $('.changePasswordContainer .cc_btn_submit').prop('disabled', true);
                        }
                    };
                    // Check for valdation on submit
                    cpView.resetPassword = function(){
                        var form = this.$el.find("#resetForm").serializeObject();
                        var view = this;
                        this.invoke(
                            "resetPassword",
                            {storefront:CCRZ.pagevars.storefrontName,portalUserId:CCRZ.pagevars.portalUserId},
                            form.NewPassword,
                            form.ConfirmPassword,
                            function(response){
                                if(response.success){
                                    window.location.href = '/DefaultStore/apex/ccrz__HomePage?cartID=null&store=DefaultStore';
                                }else{
                                    $.each(response.messages,function(){
                                    var message = this.message;
                                    if(this.labelId){
                                    message = CCRZ.pagevars.pageLabels[this.labelId];
                                    }
                                    view.updateError(true, message);
                                    });
                                }
                            }
                        );
                    };
                    // Delegate events
                    cpView.delegateEvents();
                });
                UTIL.hideLoader();
            }
        }
    }
});