d("custLoginView",['ccrz','util'], function(CCRZ, UTIL) {

    return {
        extendCustomLoginView: function() {
            // Create Custom Login View
            if(CCRZ.pagevars.isGuest){
                CCRZ.views.custLoginView = CCRZ.CloudCrazeView.extend({
                    templatePhone : CCRZ.util.template(CCRZ.uiProperties.custLoginView.tmpl),
                    templateDesktop : CCRZ.util.template(CCRZ.uiProperties.custLoginView.tmpl),
                    viewName : "custLoginView",
                    events : {
                    "click #send2Dsk" : "doLogin",
                    "keyup .loginInput" : "enterPress",
                    "keyup .contactInput" : "enterPress",
                    "click .forgotPass" : "gotoForgotPassword",
                    'click .registerBtn' : 'handleRegisterUser',
                    'click .navigateRegister' : 'handleRegister',
                    'click .navigateLogin' : 'handleLogin',
                    'focus .inputVal input' : 'handleInputFocus',
                    'blur .inputVal input' : 'handleInputBlur',
                    'focus .inputLogin input' : 'handleInputFocus',
                    'blur .inputLogin input' : 'handleInputBlur'
                    },
                    init : function(){
                        var v = this;
                        v.render();
                    },
                    getURLParameter : function(name) {
                        return decodeURI(
                            (RegExp(name + '=' + '(.+?)(&|$)').exec(location.search)||[,null])[1]
                        );
                    },
                    render : function(){
                        var v = this;
                        if(CCRZ.display.isPhone()){
                            this.setElement($(CCRZ.uiProperties.custLoginView.selector));
                            this.$el.html(this.templatePhone());
                        }else{
                            this.setElement($(CCRZ.uiProperties.custLoginView.selector));
                            this.$el.html(this.templateDesktop());
                        }
                        v.validateForm();
                    },
                    handleInputFocus : function(event){
                        $(event.target).prop('readonly', false);
                        UTIL.hideValidate(event.target);
                    },
                    handleInputBlur : function(event){
                        $(event.target).prop('readonly', true);
                        if (UTIL.validate(event.target) == false) {
                            UTIL.showValidate(event.target);
                        } else {
                            UTIL.hideValidate(event.target);
                            $('.messagingSection-loginModal-Error').html('');
                            $('.messagingSection-loginModal-Error').css('display', 'hide');
                            $('.messagingSection-registerModal-Error').html('');
                            $('.messagingSection-registerModal-Error').css('display', 'hide');
                        }
                    },
                    handleLogin : function(){
                        //$('#loginModal .modal-dialog').removeClass('modal-lg');
                    },
                    handleRegister : function(){
                        $('#loginModal .modal-dialog').addClass('modal-lg');
                    },
                    enterPress : function(e){
                        var code = e.which; // recommended to use e.which, it's normalized across browsers
                        if(code==13)e.preventDefault();
                        if(code==13||code==186){
                            this.doLogin(e);
                        }
                    },
                    validateForm : function(){
                        $("#registerFormDsk").validate({
                            invalidHandler: function(event, validator) {
                             CCRZ.handleValidationErrors(event, validator, 'main-messagingSection-Error', false);
                            },
                            rules: {
                            'firstName': {
                                required: true
                            },
                            'lastName': {
                                required: true
                            },
                            'email': {
                                required: true,
                                email: true
                            },
                             'password': {
                              required: true
                             },
                             'confirmPassword': {
                              required: true
                             }
                            },
                            messages: {
                             'firstName': {
                              required: CCRZ.processPageLabelMap('KFB2B_all_missingFirstName').toString()
                             },
                             'lastName': {
                              required: CCRZ.processPageLabelMap('KFB2B_all_missingLastName').toString()
                             },
                             'email': {
                                required: CCRZ.processPageLabelMap('KFB2B_all_missingEmail').toString(),
                                email : CCRZ.processPageLabelMap('KFB2B_all_emailInvalidFormat').toString()
                             },
                            'password': {
                            required: CCRZ.processPageLabelMap('KFB2B_all_missingPassword').toString()
                            },
                             'confirmPassword': {
                              required: CCRZ.processPageLabelMap('KFB2B_all_missingConfirmPassword').toString()
                             }
                            },
                            errorPlacement: function(error, element) { }
                        });
                        $("#loginFormDsk").validate({
                            invalidHandler: function(event, validator) {
                             CCRZ.handleValidationErrors(event, validator, 'main-messagingSection-Error', false);
                            },
                            rules: {
                                'emailField': {
                                    required: true,
                                    email : true
                                },
                                'passwordField': {
                                    required: true
                                }
                            },
                            messages: {
                                'emailField': {
                                required: CCRZ.processPageLabelMap('KFB2B_all_missingEmail').toString(),
                                email : CCRZ.processPageLabelMap('KFB2B_all_emailInvalidFormat').toString()
                                },
                                'passwordField': {
                                required: CCRZ.processPageLabelMap('KFB2B_all_missingPassword').toString()
                                }
                            },
                            errorPlacement: function(error, element) { }
                        });
                    },
                    doLogin : function(event){
                        let frmTarg = '#loginFormDsk';
                        if(UTIL.validateAllFieldTypesById('.inputLogin input')){
                            $('.messagingSection-loginModal-Error').css('display', 'none');
                            $('.messagingSection-loginModal-Error').html('');
                            var loginForm = $(frmTarg).serializeObject(), isStoreNameURL = false, startURL = '/ccrz__HomePage';
                            let href = window.location.href, items = href.split(CCRZ.pagevars.storefrontName);
                            if(href.indexOf(CCRZ.pagevars.storefrontName) > -1){
                                isStoreNameURL = true;
                            } else {
                                if(window.location.pathname.length > 1){ 
                                    let vanityItems = href.split(window.location.pathname);
                                    if(vanityItems.length > 1){
                                        startURL = window.location.pathname + (vanityItems[1]).replace('#','');
                                    } else {
                                        startURL = window.location.pathname;
                                    }
                                }
                            }
                            if(!_.isUndefined(CCRZ.pagevars.currentCartID) && CCRZ.pagevars.currentCartID != null){
                                loginForm['isCart'] = true;
                                loginForm['cartEncId'] = CCRZ.pagevars.currentCartID;
                            } else {
                                loginForm['isCart'] = false;
                            }
                            if(CCRZ.pagevars.currentPageName == 'ccrz__CCSiteLogin' || _.isUndefined(items[1])){
                                if(CCRZ.pagevars.currentPageName == 'ccrz__CCSiteLogin'){
                                    startURL = '/ccrz__HomePage';
                                }
                                loginForm['startURL'] = CCRZ.pagevars.sitePrefix + startURL;
                            } else {
                                loginForm['startURL'] = CCRZ.pagevars.sitePrefix + items[1];
                            }
                            //loginForm['startURL'] = '/DefaultStore/ccrz__ProductDetails?sku=BB01&isReprint=false&cartID=&portalUser=&store=&cclcl=en_US';
                            var view = this;
                            UTIL.showLoader();
                            CCRZ.remoteModel.loginUser(JSON.stringify(loginForm), function(res, event){
                                if(res && res.success && res.data && res.data.isLogin && res.data.pageReference){
                                    window.location = res.data.pageReference;
                                } else if(res && !res.data.isLogin){
                                    // Error Handling
                                    $('.messagingSection-loginModal-Error').html(CCRZ.processPageLabelMap('KFB2B_all_loginError').toString());
                                    $('.messagingSection-loginModal-Error').css('display', 'block');
                                    UTIL.hideLoader();
                                } else {
                                    $('.messagingSection-loginModal-Error').html(CCRZ.processPageLabelMap('KFB2B_all_loginErrorService').toString());
                                    $('.messagingSection-loginModal-Error').css('display', 'block');
                                    UTIL.hideLoader();
                                }
                            });
                        } else {
                            $('.messagingSection-loginModal-Error').html(CCRZ.processPageLabelMap('KFB2B_all_loginRequiredFields').toString());
                            $('.messagingSection-loginModal-Error').css('display', 'block');
                            $('#loginModal .modal-body').animate({ scrollTop: 0 }, 'slow');
                        }
                    },
                    handleRegisterUser : function(evt){
                        if(UTIL.validateAllFieldTypesById('.inputVal input')){
                            let registerformObj = $('#registerFormDsk').serializeObject();
                            if(registerformObj.password == registerformObj.confirmPassword){ 
                                $('.messagingSection-registerModal-Error').css('display', 'none');
                                $('.messagingSection-registerModal-Error').html('');
                                let href = window.location.href, items = href.split(CCRZ.pagevars.storefrontName), isStoreNameURL = false, startURL = '/ccrz__HomePage?isNewUser=true#';
                                if(href.indexOf(CCRZ.pagevars.storefrontName) > -1){
                                    isStoreNameURL = true;
                                } else {
                                    if(window.location.pathname.length > 1){
                                        let vanityItems = href.split(window.location.pathname);
                                        if(vanityItems.length > 1){
                                            startURL = window.location.pathname + (vanityItems[1]).replace('#','');
                                        } else {
                                            startURL = window.location.pathname;
                                        }
                                    }
                                }
                                if(!_.isUndefined(CCRZ.pagevars.currentCartID) && CCRZ.pagevars.currentCartID != null && CCRZ.pagevars.currentCartID != ''){
                                    registerformObj['isCart'] = true;
                                    registerformObj['cartEncId'] = CCRZ.pagevars.currentCartID;
                                } else {
                                    registerformObj['isCart'] = false;
                                }
                                let startPath = items[1];
                                if(!_.isUndefined(startPath) && startPath.indexOf('?') > -1){
                                    startPath = startPath.replace('?', '?isNewUser=true&');
                                } else {
                                    startPath = startURL;
                                }
                                if(CCRZ.pagevars.currentPageName == 'ccrz__CCSiteLogin'){
                                    registerformObj['startURL'] = CCRZ.pagevars.sitePrefix + '/ccrz__HomePage?isNewUser=true';
                                } else {
                                    registerformObj['startURL'] = CCRZ.pagevars.sitePrefix + startPath;
                                }
                                UTIL.showLoader();
                                CCRZ.remoteModel.registerNewUser(JSON.stringify(registerformObj), function(res, event){
                                    if(res && res.success && res.data && res.data.pageReference){
                                        window.location = res.data.pageReference;
                                    } else if(res == null || _.isUndefined(res.data.pageReference)){
                                        // Error Handling
                                        $('.messagingSection-registerModal-Error').html(CCRZ.processPageLabelMap('KFB2B_all_loginDuplicateEmailError').toString());
                                        $('.messagingSection-registerModal-Error').css('display', 'block');
                                        UTIL.hideLoader();
                                    }
                                });
                            } else {
                                $('#confirmPassword').parent().attr('data-validate', CCRZ.processPageLabelMap('KFB2B_all_passwordMatchError').toString());
                                UTIL.showValidate($('#confirmPassword'));
                            }
                        } else {
                            $('.messagingSection-registerModal-Error').html(CCRZ.processPageLabelMap('KFB2B_all_loginRequiredFields').toString());
                            $('.messagingSection-registerModal-Error').css('display', 'block');
                            $('#loginModal .modal-body').animate({ scrollTop: 0 }, 'slow');
                        }
                    },
                    gotoForgotPassword: function(event) {
                        window.open(window.location.origin + CCRZ.pagevars.sitePrefix + "/ccrz__CCForgotPassword?cartID=" + CCRZ.pagevars.currentCartID + getCSRQueryString(), '_self');
                    },
                    setStartURL : function(){
                        let startURL = (CCRZ.pagevars.currentPageURL).replace(window.location.origin, '');
                        startURL = encodeURIComponent(startURL);
                        //startURL = startURL + '&cartID=' + CCRZ.pagevars.currentCartID + getCSRQueryString();
                        window.history.pushState('','', '?startURL=' + startURL);
                        return startURL;
                    }
                });
        
                CCRZ.custLoginView = new CCRZ.views.custLoginView();
            }
        } 
    }
});

