d("loginView",['ccrz', 'util'], function(CCRZ, UTIL) {
    return {
        extendLoginView: function() {
            $('.breadcrumb').addClass('hide');
            CCRZ.pubSub.once('view:loginView:refresh', function(loginView){
                loginView.events['click .registerBtn'] = 'handleRegisterUser';
                loginView.events['click .navigateRegister'] = 'handleRegister';
                loginView.events['click .navigateLogin'] = 'handleLogin';
                loginView.handleLogin = function(){
                    $('#loginModal .modal-dialog').removeClass('modal-lg');
                    //$('#loginModal .registerAd').addClass('hide');
                };
                loginView.handleRegister = function(){
                    $('#loginModal .modal-dialog').addClass('modal-lg');
                    //$('#loginModal .registerAd').removeClass('hide');
                };
                loginView.handleRegisterUser = function(evt){
                    let registerformObj = $('#registerFormDsk').serializeObject();
                    CCRZ.remoteModel.registerNewUser(JSON.stringify(registerformObj), function(res, event){
                        if(res && res.success && res.data){
                            CCRZ.headerView.doLogin(res.data.username, res.data.password, function(error){
                                // Error Handle for login
                            });
                        } else if(res && !res.success){
                            // Error Handling
                        } else if(res == null){
                            // Error Handling
                        }
                    });
                };
                loginView.render = function(){
                    var v = this;
                    if(CCRZ.display.isPhone()){
                     this.setElement($(CCRZ.uiProperties.loginView.phone.selector));
                     this.$el.html(this.templatePhone(v.model.toJSON()));
                    }else{
                     this.setElement($(CCRZ.uiProperties.loginView.desktop.selector));
                     this.$el.html(this.templateDesktop(v.model.toJSON()));
                    }
                    $('#loginModal').modal({backdrop: true, show: true, backdrop: 'static', keyboard: false}); 
                    //$('#loginModal').modal({backdrop: true, show: true}); 
                    $('#loginModal').removeClass('fade');
                    $('.modal-backdrop').removeClass('fade');
                    CCRZ.custLoginView.render();
                    UTIL.hideLoader();
                    var qsErr = queryString("error");
                    if(qsErr && _.isArray(qsErr)){
                     var errorStr = _.escape(qsErr[0]);
                     if(errorStr){
                      CCRZ.pubSub.trigger('pageMessage', CCRZ.createPageMessage('ERROR', 'messagingSection-Error', errorStr));
                     }
                    }
                    var qsInfo = queryString("message");
                    if(qsInfo && _.isArray(qsInfo)){
                     var infoStr = _.escape(qsInfo[0]);
                     if(infoStr){
                      CCRZ.pubSub.trigger('pageMessage', CCRZ.createPageMessage('INFO', 'messagingSection-Info', infoStr));
                     }
                    }
                    CCRZ.pubSub.trigger("view:"+this.viewName+":refresh", this);
                };
                loginView.delegateEvents();
                loginView.render();
            });
        }
    }
});