d("registerView",['ccrz', 'util'], function(CCRZ, UTIL) {
    return {
        extendRegisterView: function() {
            let isRefresh = false;
            CCRZ.pubSub.on('view:newCustomerView:refresh', function(view){
                if(!isRefresh){
                    view.events['click #useBillingAddress'] = 'handleUseBillingAddress';
                    view.events['click #tcCheck'] = 'handleTcCheck';
                    view.events['click  .submit'] = 'handleSubmit';

                    view.renderDesktop = function() {
                        var v = this;
                        v.$el.html('');
                        v.setElement($(CCRZ.uiProperties.newCustomerView.desktop.selector));
                        v.$el.html(v.templateDesktop(v.model.toJSON()));
                        v.renderStateLists();
                        v.initValidationDesktop();
                        UTIL.hideLoader();
                    };
                    view.handleSubmit = function(event){
                        if (jQuery('#newCustomerForm').valid()) {
                            var v = this;
                            if($('#useBillingAddress')[0].checked){
                                jQuery("#shippingStateSection select").prop('disabled', false);
                            }
                            toggleDisableItems(false);
                            let newCustomerJSON = jQuery('#newCustomerForm').serializeObject();
                            toggleDisableItems(true);
                            if($('#useBillingAddress')[0].checked){
                                jQuery("#shippingStateSection select").prop('disabled', true);
                            }
                            newCustomerJSON['type'] = 'create';
                            UTIL.showLoader();
                            CCRZ.remoteModel.createLead(JSON.stringify(newCustomerJSON), function(res, evt){
                                if(res && res.success && res.data){
                                    $('.submit').addClass('disabled');
                                    $('#tcCheck').prop('disabled', true);
                                    window.open( UTIL.goToLogin(), '_self');
                                    /*
                                    CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('INFO', "error_messages_section", 'We have notified and someone will contact you soon!'));
                                    setTimeout(function(){
                                        $('.error_messages_section').css('display', 'none');
                                    }, 5000);
                                    */
                                } else {
                                    // Error Handling
                                    CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "error_messages_section", 'Error creating request, Contact Administrator!'));
                                    setTimeout(function(){
                                        $('.error_messages_section').css('display', 'none');
                                    }, 5000);
                                }
                                document.body.scrollTop = document.documentElement.scrollTop = 0;
                            });
                        } else {
                            document.body.scrollTop = document.documentElement.scrollTop = 0;
                        }
                    };
                    view.handleTcCheck = function(event){
                        if(event.target.checked){
                            $('.submit.cc_submit').removeClass('disabled');
                        } else {
                            $('.submit.cc_submit').addClass('disabled');
                        }
                    };
                    view.handleUseBillingAddress = function(event){
                        var v = this;
                        if(event.target.checked){
                            jQuery("input[name='shippingAddress.address1']").val(jQuery("input[name='billingAddress.address1']").val());
                            jQuery("input[name='shippingAddress.address2']").val(jQuery("input[name='billingAddress.address2']").val());
                            jQuery("input[name='shippingAddress.address3']").val(jQuery("input[name='billingAddress.address3']").val());
                            jQuery("input[name='shippingAddress.city']").val(jQuery("input[name='billingAddress.city']").val());
                            jQuery("input[name='shippingAddress.postalCode']").val(jQuery("input[name='billingAddress.postalCode']").val());
                            var billingCountry = jQuery('.billing.countryListing').val();
                            var billingState = jQuery('.billingstate').val();
                            jQuery('.shipping.countryListing').val(billingCountry);
                            v.renderShippingStateList(billingState, billingCountry);
                            jQuery("input[name='shippingAddress.address1']").prop('readonly', true);
                            jQuery("input[name='shippingAddress.address2']").prop('readonly', true);
                            jQuery("input[name='shippingAddress.address3']").prop('readonly', true);
                            jQuery("input[name='shippingAddress.city']").prop('readonly', true);
                            jQuery("input[name='shippingAddress.postalCode']").prop('readonly', true);
                            jQuery("#shippingStateSection select").prop('disabled', true);
                        } else {
                            // Default values for address
                            jQuery("input[name='shippingAddress.address1']").val('');
                            jQuery("input[name='shippingAddress.address2']").val('');
                            jQuery("input[name='shippingAddress.address3']").val('');
                            jQuery("input[name='shippingAddress.city']").val('');
                            jQuery("input[name='shippingAddress.postalCode']").val('');
                            jQuery('.shipping.countryListing').val('US');
                            v.renderShippingStateList('', 'US');
                            jQuery("input[name='shippingAddress.address1']").prop('readonly', false);
                            jQuery("input[name='shippingAddress.address2']").prop('readonly', false);
                            jQuery("input[name='shippingAddress.address3']").prop('readonly', false);
                            jQuery("input[name='shippingAddress.city']").prop('readonly', false);
                            jQuery("input[name='shippingAddress.postalCode']").prop('readonly', false);
                            jQuery("#shippingStateSection select").prop('disabled', false);
                        }
                        jQuery('#newCustomerForm').valid();
                    };
                    view.initValidationDesktop = function() {
                        jQuery('#newCustomerForm').validate({
                         invalidHandler : function(event, validator) {
                          if(!CCRZ.disableAdaptive) {
                           CCRZ.handleValidationErrors(event, validator, 'error_messages_section', false);
                          }
                         },
                         rules : {
                          firstName       : { required : true },
                          lastName       : { required : true },
                          primaryPhone      : { required : true },
                          username       : { required : true , email: true},
                          companyName      : { required : true },
                          companyPhone      : { required : true },
                          website      : { required : true },
                          sundayCirculation      : { required : true },
                          dailyCirculation      : { required : true },
                          monthlyVisitors      : { required : true },
                          NewPassword      : { required : CCRZ.getPageConfig('UR.DirLogin', true) },
                          ConfirmPassword     : { required : CCRZ.getPageConfig('UR.DirLogin', true) },
                          'billingAddress.address1'   : { required : true },
                          'billingAddress.city'    : { required : true },
                          'billingAddress.postalCode'  : { required : true },
                          'shippingAddress.address1'   : { required : true },
                          'shippingAddress.city'    : { required : true },
                          'shippingAddress.postalCode'  : { required : true }
                         },
                         messages : {
                          firstName       : { required : CCRZ.pagevars.pageLabels['SR_FNameRequired']},
                          lastName       : { required : CCRZ.pagevars.pageLabels['SR_LNameRequired']},
                          primaryPhone      : { required : CCRZ.pagevars.pageLabels['SR_PhoneRequired']},
                          username       : { required : CCRZ.pagevars.pageLabels['SR_UserNameRequired'], email : CCRZ.pagevars.pageLabels['SR_UserNameInvalidFormat']},
                          companyName      : { required : CCRZ.pagevars.pageLabels['SR_CompanyNameRequired'] },
                          companyPhone      : { required : 'Company Phone is required' },
                          website      : { required : 'Website is required' },
                          sundayCirculation      : { required : 'Sunday Circulation is required' },
                          dailyCirculation      : { required : 'Daily Circulation is required' },
                          monthlyVisitors      : { required : 'Monthly Visitors is required' },
                          NewPassword      : { required : CCRZ.pagevars.pageLabels['SR_PasswordRequired'] },
                          ConfirmPassword     : { required : CCRZ.pagevars.pageLabels['SR_ConfPasswordRequired']},
                          'billingAddress.address1'   : { required : CCRZ.pagevars.pageLabels['SR_BillAddrRequired']},
                          'billingAddress.city'    : { required : CCRZ.pagevars.pageLabels['SR_BillCityRequired']},
                          'billingAddress.postalCode'  : { required : CCRZ.pagevars.pageLabels['SR_BillPostCodeRequired']},
                          'shippingAddress.address1'   : { required : CCRZ.pagevars.pageLabels['SR_ShipAddrRequired']},
                          'shippingAddress.city'    : { required : CCRZ.pagevars.pageLabels['SR_ShipCityRequired']},
                          'shippingAddress.postalCode'  : { required : CCRZ.pagevars.pageLabels['SR_ShipPostCodeRequired']}
                         },
                         errorElement: "em",
                         errorPlacement: function ( error, element ) {
                          // Needed for bootstrap 3 (per validator documentation)
                          if(CCRZ.disableAdaptive) {
                           error.addClass( "help-block" );
                    
                           if ( element.prop( "type" ) === "checkbox" ) {
                            error.insertAfter( element.parent( "label" ) );
                           } else {
                            error.insertAfter( element );
                           }
                          }
                         },
                         highlight: function ( element, errorClass, validClass ) {
                          if(CCRZ.disableAdaptive) {
                           $(element).parents(".col-sm-4").addClass("has-error").removeClass("has-success");
                          }
                         },
                         unhighlight: function (element, errorClass, validClass) {
                          if(CCRZ.disableAdaptive) {
                           $(element).parents(".col-sm-4").addClass("has-success").removeClass("has-error");
                          }
                         }
                        });
                    }
                    view.delegateEvents();
                    isRefresh = true;
                    let reqData = [
                        { "name": 'sundayCirculation', "objectName": 'Lead', "fieldName": 'KFB2B_Sunday_Circulation__c' },
                        { "name": 'dailyCirculation', "objectName": 'Lead', "fieldName": 'KFB2B_Daily_Circulation__c' },
                        { "name": 'monthlyVisitors', "objectName": 'Lead', "fieldName": 'KFB2B_Monthly_Unique_Visitors_Digital__c' }
                    ];
                    CCRZ.remoteModel.getRegisterInitData(JSON.stringify(reqData), function(res, event){
                        if(res && res.success && res.data){
                            view.model.attributes['sundayCirculation'] = res.data['sundayCirculation'];
                            view.model.attributes['dailyCirculation'] = res.data['dailyCirculation'];
                            view.model.attributes['monthlyVisitors'] = res.data['monthlyVisitors'];
                            view.render();
                        } else {
                            // Error handling
                        }
                    });
                } else {
                    toggleDisableItems(true);
                }
            });

            function toggleDisableItems(isDisable){
                $('.countryListing').each(function(item){
                    $(this).prop('disabled', isDisable);
                });
            }
        }
    }
});